package net.pricefx.common.apibuilder;

import java.util.ArrayList;
import java.util.List;

import net.pricefx.common.apibuilder.calculationflowaction.CalculationFlowActionExtensions;
import net.pricefx.common.apibuilder.chart.ChartBuilderExtensions;
import net.pricefx.common.apibuilder.clicoll.CalculableLineItemCollectionExtensions;

public class BuilderExtensions {

	public static final class GroovyDefaultImport {

		public GroovyDefaultImport(String alias, Class<?> className) {
			this.alias = alias;
			this.clazz = className;
		}

		private String alias;
		private Class<?> clazz;

		public String alias() {	return alias;	}
		public String className() {	return clazz.getName(); }

	}

	public static boolean isBuilderClass(Object o) {
		return
			ChartBuilderExtensions.isBuilderClass(o) ||
			CalculableLineItemCollectionExtensions.isBuilderClass(o) ||
			CalculationFlowActionExtensions.isBuilderClass(o);
	}

	public static List<GroovyDefaultImport> getGroovyDefaultImports() {
		ArrayList<GroovyDefaultImport> defaultImports = new ArrayList<>();
		defaultImports.addAll(ChartBuilderExtensions.getGroovyDefaultImports());
		defaultImports.addAll(CalculableLineItemCollectionExtensions.getGroovyDefaultImports());
		defaultImports.addAll(CalculationFlowActionExtensions.getGroovyDefaultImports());
		return defaultImports;
	}

	// class.isInstance not supported by gwt compiler
	public static boolean isDefaultImport(Object o) {
		return
			ChartBuilderExtensions.isDefaultImport(o) ||
			CalculableLineItemCollectionExtensions.isDefaultImport(o) ||
			CalculationFlowActionExtensions.isDefaultImport(o);
	}

	public static boolean isClass(Object o) {
		return
			ChartBuilderExtensions.isClass(o) ||
			CalculableLineItemCollectionExtensions.isClass(o) ||
			CalculationFlowActionExtensions.isClass(o);
	}

}
