package net.pricefx.common.apibuilder.chart;

import java.math.BigDecimal;

import net.pricefx.common.apibuilder.BacklinkBuilder;
import net.pricefx.common.apibuilder.ObjectIdentity;

public class Expression<O extends ObjectIdentity> extends BacklinkBuilder<O> {

	public Expression(final O backLink, final String instanceId, final String classId) {
		super(instanceId, classId, backLink);
	}

	public Expression<O> setExpression(final String expression) {
		addInvocation("setExpression", expression);
		return this;
	}

	public Expression<O> setDefaultValue(final BigDecimal defaultValue) {
		addInvocation("setDefaultValue", defaultValue);
		return this;
	}

	public Expression<O> setDescription(final String description) {
		addInvocation("setDescription", description);
		return this;
	}

}